% call inverter model
inverter

% simulate with stochastic solver
state_mi = Mobj.species(2);
state_pi = Mobj.species(3);
state_pipi = Mobj.species(4);
state_do = Mobj.species(5);
state_pipido = Mobj.species(6);
state_degraded_pi = Mobj.species(7);
state_degraded_pipi = Mobj.species(8);
state_pign = Mobj.species(10);
state_pipign = Mobj.species(11);
StatesToLog = [state_do, Mobj.species(1)]; % choose which species to track
cs = getconfigset(Mobj);
set(cs, 'SolverType', 'ssa');
set(cs.RuntimeOptions, 'StatesToLog', StatesToLog);
cs.SolverOptions.LogDecimation = 1;
cs.StopTime = 60;

% the magic black box that all our numbers go into
[t_ssa, x_ssa] = sbiosimulate(Mobj, cs);

% convert to PoPS
pops_o = [0:1:length(x_ssa)-1];
for index=1:length(x_ssa),
    do_free = x_ssa(index,1);
    pops_o(index) = pops_o_max * (do_free / gene_o) + leaky_o;
end

set(gcf, 'color', 'white');
figure(1);
plot(t_ssa,pops_o);
title('Output PoPS vs. time');
xlabel('Time (seconds)');
ylabel('PoPS out');