% graph pops vs. proteins

% call tester base
testerbase

% choose mode:
% mode 0: dep is pops_i, indep is total protein
% mode 1: dep is total protein, indep is pops_o
testermode = 1;

% simulate with stochastic solver
state_mi = Mobj.species(2);
state_pi = Mobj.species(3);
state_pipi = Mobj.species(4);
state_do = Mobj.species(5);
state_pipido = Mobj.species(6);
state_degraded_mi = Mobj.species(7);
state_degraded_pi = Mobj.species(8);
state_degraded_pipi = Mobj.species(9);
state_pign = Mobj.species(11);
state_pipign = Mobj.species(12);
StatesToLog = [state_do, state_pi, state_pipi, state_pipido, state_pign, state_pipign];
cs = getconfigset(Mobj);
set(cs, 'SolverType', 'ssa');
set(cs.RuntimeOptions, 'StatesToLog', StatesToLog);
cs.SolverOptions.LogDecimation = 1;
cs.StopTime = 30;

pops_to_test = [0:.1:1];
runs_to_test = 5;

pops_o = [1:1:length(pops_to_test)*runs_to_test];
input_pops = [1:1:length(pops_to_test)*runs_to_test];
counter = 1;

% MODE 0
if testermode == 0
    piT = [1:1:length(pops_to_test)*runs_to_test];
    for pops_now=pops_to_test
        for run_now=1:runs_to_test
        set(Pobj1,'Value',pops_now);
            [t_ssa, x_ssa] = sbiosimulate(Mobj, cs);
            pi = x_ssa(:,2);
            pipi = x_ssa(:,3);
            pipido = x_ssa(:,4);
            pign = x_ssa(:,5);
            pipign = x_ssa(:,6);
            piT(counter) = 2*(pipi(length(pipi)) + pipido(length(pipido)) + pipign(length(pipign))) + pi(length(pi)) + pign(length(pign));
            input_pops(counter) = pops_now;
            counter = counter + 1;
        end
    end
end
% END MODE 0

% MODE 1
if testermode == 1
for pops_now=pops_to_test
    set(Pobj1,'Value',pops_now);
    for run_now=1:runs_to_test
        %run the simulation
        [t_ssa, x_ssa] = sbiosimulate(Mobj, cs);
        %calculate output pops
        do_free = x_ssa(length(x_ssa));
        pops_o(counter) = pops_o_max * (do_free / gene_o) + leaky_o;
            pi = x_ssa(:,2);
            pipi = x_ssa(:,3);
            pipido = x_ssa(:,4);
            pign = x_ssa(:,5);
            pipign = x_ssa(:,6);
            piT(counter) = 2*(pipi(length(pipi)) + pipido(length(pipido)) + pipign(length(pipign))) + pi(length(pi)) + pign(length(pign));
        input_pops(counter) = pops_now;
        counter = counter + 1;
    end
end
end
% END MODE 1

set(gcf, 'color', 'white');
figure(1);
% plot
if testermode == 0
    scatter(input_pops,piT)
    title('Total proteins vs. input PoPS');
    xlabel('Input PoPS');
    ylabel('Total proteins');
end
if testermode == 1
    scatter(piT, pops_o)
    title('Output PoPS vs. total proteins');
    xlabel('Total proteins');
    ylabel('Output PoPS');
end