testerbase

% simulate with stochastic solver
state_mi = Mobj.species(2);
state_pi = Mobj.species(3);
state_pipi = Mobj.species(4);
state_do = Mobj.species(5);
state_pipido = Mobj.species(6);
state_degraded_mi = Mobj.species(7);
state_degraded_pi = Mobj.species(8);
state_degraded_pipi = Mobj.species(9);
state_pign = Mobj.species(11);
state_pipign = Mobj.species(12);
StatesToLog = [state_do]; % choose which species to track
cs = getconfigset(Mobj);
set(cs, 'SolverType', 'ssa');
set(cs.RuntimeOptions, 'StatesToLog', StatesToLog);
cs.SolverOptions.LogDecimation = 1;
cs.StopTime = 60;

pops_to_test = [0:.05:1];
runs_to_test = 5;

pops_o = [1:1:length(pops_to_test)*runs_to_test];
input_pops = [1:1:length(pops_to_test)*runs_to_test];
counter = 1;

for pops_now=pops_to_test
    set(Pobj1,'Value',pops_now);
    for run_now=1:runs_to_test
        %run the simulation
        [t_ssa, x_ssa] = sbiosimulate(Mobj, cs);
        %calculate output pops
        do_free = x_ssa(length(x_ssa));
        pops_o(counter) = pops_o_max * (do_free / gene_o) + leaky_o;
        input_pops(counter) = pops_now;
        counter = counter + 1;
    end
end

difference = [1:1:counter-1];
diff_lowest = 1000;
index_of_lowest = 0;
for index=difference
    difference(index) = pops_o(index) - input_pops(index);
    if difference(index) < diff_lowest
        index_of_lowest = index;
        diff_lowest = difference(index);
    end
end

trp_approx = mean([pops_o(index_of_lowest) input_pops(index_of_lowest)]);

set(gcf, 'color', 'white');
figure(1);
scatter(input_pops,pops_o)
right = 0;
wrong = 0;
for new_index=1:length(pops_o)
    hold on
    if input_pops(new_index) < trp_approx
        if pops_o(new_index) > trp_approx
            plot(input_pops(new_index),pops_o(new_index),'go')
            right = right + 1;
        else
            plot(input_pops(new_index),pops_o(new_index),'ro')
            wrong = wrong + 1;
        end
    end
    if input_pops(new_index) > trp_approx
        if pops_o(new_index) < trp_approx
            plot(input_pops(new_index),pops_o(new_index),'go')
            right = right + 1;
        end
        if pops_o(new_index) > trp_approx
            plot(input_pops(new_index),pops_o(new_index),'ro')
            wrong = wrong + 1;
        end
    end
end

hold on
plot(trp_approx,trp_approx,'bx')
hold on
x = [0 input_pops(counter-1)];
y = x;
plot(x,y,':')
title('Output PoPS vs. input PoPS');
xlabel('Input PoPS');
ylabel('Output PoPS');
text(mean(input_pops),max(pops_o)*.75,num2str(wrong/(right+wrong)))
text(mean(input_pops),max(pops_o)*.8,'Percent wrong')