% call inverter model
inverter

% simulate with stochastic solver
state_mi = Mobj.species(2);
state_pi = Mobj.species(3);
state_pipi = Mobj.species(4);
state_do = Mobj.species(5);
state_pipido = Mobj.species(6);
state_degraded_mi = Mobj.species(7);
state_degraded_pi = Mobj.species(8);
state_degraded_pipi = Mobj.species(9);
state_pign = Mobj.species(11);
state_pipign = Mobj.species(12);
StatesToLog = [state_do]; % choose which species to track
cs = getconfigset(Mobj);
set(cs, 'SolverType', 'ssa');
set(cs.RuntimeOptions, 'StatesToLog', StatesToLog);
cs.SolverOptions.LogDecimation = 1;
cs.StopTime = 5;

pi = 22;
pipi = 23;
pipido = 10;
pign = 215;
pipign = 237;

% initial conditions
s = sbioselect(Mobj, 'Type', 'species', 'Name', 'pi');
s.InitialAmount = pi;
s = sbioselect(Mobj, 'Type', 'species', 'Name', 'do');
s.InitialAmount = 0;
s = sbioselect(Mobj, 'Type', 'species', 'Name', 'pipi');
s.InitialAmount = pipi;
s = sbioselect(Mobj, 'Type', 'species', 'Name', 'pipido');
s.InitialAmount = pipido;
s = sbioselect(Mobj, 'Type', 'species', 'Name', 'pign');
s.InitialAmount = pign;
s = sbioselect(Mobj, 'Type', 'species', 'Name', 'pipign');
s.InitialAmount = pipign;
set(Pobj1,'Value',0);

% the magic black box that all our numbers go into
[t_ssa, x_ssa] = sbiosimulate(Mobj, cs);

% convert to PoPS
pops_o = [0:1:length(x_ssa)-1];
for index=1:length(x_ssa),
    do_free = x_ssa(index);
    pops_o(index) = pops_o_max * (do_free / gene_o) + leaky_o;
end

% smooth it out
%stepsize = 0.5;
%slices = [0:stepsize:cs.StopTime];
%smooth = interp1(t_ssa,x_ssa,slices,'linear');

set(gcf, 'color', 'white');
figure(1);
plot(t_ssa,pops_o,'m');
%plot(slices,smooth,'m')
title('Output PoPS vs. time');
xlabel('Time (seconds)');
ylabel('PoPS out');
xlim([cs.StopTime-5 cs.StopTime])